<?php

namespace App\Http\Controllers\Auth;

use App\User;
use App\role;
use App\stage;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Validator;
use Illuminate\Foundation\Auth\RegistersUsers;

class RegisterController extends Controller
{
    /*
    |--------------------------------------------------------------------------
    | Register Controller
    |--------------------------------------------------------------------------
    |
    | This controller handles the registration of new users as well as their
    | validation and creation. By default this controller uses a trait to
    | provide this functionality without requiring any additional code.
    |
    */

    use RegistersUsers;

    /**
     * Where to redirect users after registration.
     *
     * @var string
     */
    protected $redirectTo = '/home';

    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('guest');
    }

    /**
     * Get a validator for an incoming registration request.
     *
     * @param  array  $data
     * @return \Illuminate\Contracts\Validation\Validator
     */
    protected function validator(array $data)
    {
        return Validator::make($data, [
            'name' => 'required|string|max:255',
            'email' => 'required|string|email|max:255|unique:users',
            'address' => 'required|string|max:255',
            'phone' => 'required|string|max:255',
            'password' => 'required|string|min:6|confirmed',
        ]);
    }

    /**
     * Create a new user instance after a valid registration.
     *
     * @param  array  $data
     * @return \App\User
     */
    protected function create(array $data)
    {
        $company=\App\Company::create([
            'name' => $data['name'],'address' => $data['address'],'phone' => $data['phone'],'email' => $data['email'],'package_id' =>'1','theme' => 'default','expiry_date' => '2018-12-12'
        ]); $office=\App\office::create(['company_id'=>$company->id,'office'=>$data['name'],'Address'=>$data['address']]);
        role::insert([['company_id'=>$company->id,'rolename' => 'System Admin','description' => 'System Admin',
    ],['company_id'=>$company->id,'rolename' => 'Manager','description' => 'Manager',],['company_id'=>$company->id,'rolename' => 'Supervisor','description' => 'Supervisor',
    ],['company_id'=>$company->id,'rolename' => 'Sales','description' => 'Sales',
    ],]);stage::insert([['company_id'=>$company->id,'stages' => 'Lead','odds' => '10','color' => 'white',],['company_id'=>$company->id,'stages' => 'Pitched','odds' => '20','color' => 'warning', ],['company_id'=>$company->id,'stages' => 'Qualified','odds' => '40','color' => 'info',
    ],['company_id'=>$company->id,'stages' => 'Proposal','odds' => '60','color' => 'primary',],['company_id'=>$company->id,'stages' => 'Negotation','odds' => '80','color' => 'success',],['company_id'=>$company->id,'stages' => 'Won','odds' => '100','color' => 'success',],['company_id'=>$company->id,'stages' => 'Lost','odds' => '100','color' => 'danger',
    ],]);\App\source::insert([['company_id'=>$company->id,'source' => 'Agents','note' => 'Agents',],['company_id'=>$company->id,'source' => 'Adword','note' => 'Adword',
    ],['company_id'=>$company->id,'source' => 'Direct','note' => 'Direct',],['company_id'=>$company->id,'source' => 'Website','note' => 'Website',
    ],]);$role=role::select('id')->where('rolename','System Admin')->first();
        return User::create(['role_id' => $role->id,'company_id'=>$company->id,
            'firstname' => $data['name'],'email' => $data['email'],'password' => Hash::make($data['password']),
            'jobtitle' => 'System Admin','offices_id' => $office->id,
        ]);
    }
}
