<?php

namespace App\Http\Controllers;
use Illuminate\Support\Facades\Auth;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class Front extends Controller {
    //
    public function dashboard() {
        $totalrevenue=\App\crm::OfCompany(Auth::user()->company_id)->count();
        $won=\App\crm::OfCompany(Auth::user()->company_id)->join('stages', 'stages.id', '=','crms.stages_id')->groupby('stages.stages')->having('stages.stages','Won')->count();
    $leads=\App\crm::OfCompany(Auth::user()->company_id)->join('stages', 'stages.id', '=','crms.stages_id')->groupby('stages.stages')->having('stages.stages','Lead')->count();
    $closed=\App\crm::OfCompany(Auth::user()->company_id)->join('stages', 'stages.id', '=','crms.stages_id')->groupby('stages.stages')->having('stages.stages','Lost')->count();
    return view('dashboard',['totalrevenue'=>$totalrevenue,'won'=>$won,'leads'=>$leads,'closed'=>$closed]);
    }
     public function lead() {
        //$olddate = session('oldtoday');
    //$todate = session('date');
   // $todates = strtotime('+1 day', strtotime($todate));
   // $dates = date('Y-m-d', $todates);
    $leadlist= \App\crm::OfCompany(Auth::user()->company_id)->join('users', 'users.id', '=','crms.user_id' )->join('stages', 'stages.id', '=','crms.stages_id')->join('sources', 'sources.id', '=','crms.contactsource')->join('customers', 'customers.id', '=','crms.customer_id')->select('crms.id','crms.projectname','crms.date','users.firstname','users.lastname','stages.stages','customers.organisationname','sources.source')->where('stages','Lead')->orderBy('crms.created_at', 'desc')->get();
      return view('lead',['leadlist'=>$leadlist,]);  
    }  
    public function opportunities() {
     $opportunitieslist= \App\crm::OfCompany(Auth::user()->company_id)->join('users', 'users.id', '=','crms.user_id' )->join('stages', 'stages.id', '=','crms.stages_id')->join('customers', 'customers.id', '=','crms.customer_id')->select('crms.id','crms.projectid','crms.projectname','crms.date','users.firstname','users.lastname','stages.stages','stages.odds','stages.color','customers.organisationname')->wherenotin('stages',['Lead','Lost','Won'])->orderBy('crms.updated_at', 'desc')->get();
     
        return view('opportunities',['opportunitieslist'=>$opportunitieslist]);   
    } 
    public function closed() {
      $closedlist= \App\crm::OfCompany(Auth::user()->company_id)->join('users', 'users.id', '=','crms.user_id' )->join('stages', 'stages.id', '=','crms.stages_id')->join('customers', 'customers.id', '=','crms.customer_id')->select('crms.id','crms.projectid','crms.projectname','crms.tcv','users.firstname','users.lastname','stages.stages','stages.color','customers.organisationname')->wherein('stages',['Lost','Won'])->orderBy('crms.updated_at', 'desc')->get();
       return view('closed',['closedlist'=>$closedlist]);   
    } 
    public function todo() {
        $todate = session('today');
    $todates = strtotime('+1 month', strtotime($todate));
    $dates = date('Y-m-d', $todates);
    $todolist= \App\history::OfCompany(Auth::user()->company_id)->join('crms', 'histories.crm_id', '=','crms.id' )->select('crms.id','crms.projectname','histories.followup','histories.todo','histories.memo')->whereBetween('histories.followup',[$todate,$dates])->orderBy('crms.updated_at', 'desc')->get();
     return view('todo',['todolist'=>$todolist]);   
    }
    public function reports() {
        return view('reports');   
    }
    public function customers() {
        $customerlist=\App\customer::OfCompany(Auth::user()->company_id)->select('id','organisationname','contactphone','contactemail','city')->get();
        return view('customer/customers',['customerlist'=>$customerlist]);   
    } 
    public function customerview($id) {
        $crm=\App\customer::OfCompany(Auth::user()->company_id)->select('id','organisationname','busunit','countryregion', 'contactemail', 'contactfirstname','contactlastname','contactphone',
        'contactfunction','address','city','stateorprovince','pin','website','isactive')->where('id',$id)->first();
        $leadlist= \App\crm::OfCompany(Auth::user()->company_id)->join('users', 'users.id', '=','crms.user_id' )->join('stages', 'stages.id', '=','crms.stages_id')->join('sources', 'sources.id', '=','crms.contactsource')->select('crms.id','crms.projectname','crms.date','users.firstname','users.lastname','stages.stages','stages.color','sources.source')->where('customer_id',$id)->get();
    return view('customer/customerview',['crm'=>$crm,'leadlist'=>$leadlist]);   
    } 
    public function companyprofile() {
        $user=Auth::id();
        $totalprojects=\App\crm::OfCompany(Auth::user()->company_id)->count();
        $totalemp= \App\User::OfCompany(Auth::user()->company_id)->count();
        $role=\App\User::OfCompany(Auth::user()->company_id)->join('roles', 'users.role_id', '=','roles.id' )->select('rolename')->where('users.id',$user)->first();
        $companyinfo=\App\Company::OfCompany(Auth::user()->company_id)->select('name','address','description','city','phone','email','website','theme','sidecolour','topcolour')->first();
        $employeelist=\App\User::OfCompany(Auth::user()->company_id)->join('offices', 'users.offices_id', '=','offices.id' )->join('roles', 'users.role_id', '=','roles.id' )->select('users.id','firstname','lastname','email','jobtitle','users.isdeleted','rolename','office')->get();
        $officelist= \App\office::OfCompany(Auth::user()->company_id)->select('id','office','Address')->get();
        $rolelist= \App\role::OfCompany(Auth::user()->company_id)->select('id','rolename','description')->get();
        $productlist= \App\product::OfCompany(Auth::user()->company_id)->select('id','productname','productdescription')->get();
        $stagelist= \App\stage::OfCompany(Auth::user()->company_id)->select('stages','odds','color')->wherenotin('stages',['Lead','Lost','Won'])->get();
        $sourcelist=\App\source::OfCompany(Auth::user()->company_id)->select('source','note')->get();
        return view('customize/company-profile',['companyinfo'=>$companyinfo,'employeelist'=>$employeelist,'officelist'=>$officelist,'productlist'=>$productlist,'stagelist'=>$stagelist,'sourcelist'=>$sourcelist,'rolelist'=>$rolelist,'role'=>$role,'totalprojects'=>$totalprojects,'totalemp'=>$totalemp]);   
    } 
    public function newlead() {
        $stagelist= \App\stage::OfCompany(Auth::user()->company_id)->select('stages','id')->get();
        $employeelist=\App\User::OfCompany(Auth::user()->company_id)->select('firstname','lastname','id','offices_id')->get();
        $productlist= \App\product::OfCompany(Auth::user()->company_id)->select('id','productname')->get();
        $customerlist=\App\customer::OfCompany(Auth::user()->company_id)->select('organisationname','id')->get();
        $sourcelist=\App\source::OfCompany(Auth::user()->company_id)->select('source','id')->get();
        return view('newlead',['customerlist'=>$customerlist,'sourcelist'=>$sourcelist,'employeelist'=>$employeelist,'stagelist'=>$stagelist,'productlist'=>$productlist,]);   
    } 
    
}
