<?php

namespace App\Http\Controllers;
namespace App\Http\Controllers;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\User;
use App\crm;
use App\history;
use Illuminate\Support\Facades\Redirect;
use Illuminate\Support\Facades\Auth;
use Illuminate\Foundation\Auth\AuthenticatesUsers;
class ProjectController extends Controller
{ 
    use AuthenticatesUsers;
    protected $redirectTo = '/dashboard';

    /**
     * Create a new controller instance.
     *
     * @return void
     */
 

 protected function view($id)
    {
      $data['id'] = $id;
      $crmdata = crm::OfCompany(Auth::user()->company_id)->select('user_id')->where('id', $data['id'])->first();
     
        $owner=$crmdata->user_id;
        $employee= Auth::id();
        
        if($owner==$employee)
        {
            return $this->projectowner($id);
        }elseif ($owner != $employee) {
              return $this->projectowner($id);
          //return $this->projecthead($id,$owner,$employee);   
        }
        
       // return $employee;
        //return $owner;
    }
    protected function projectowner($id){
        $crm= crm::OfCompany(Auth::user()->company_id)->join('users', 'users.id', '=','crms.user_id' )->join('customers', 'customers.id', '=','crms.customer_id' )->join('sources', 'sources.id', '=','crms.contactsource' )->join('stages', 'stages.id', '=','crms.stages_id' )->join('products', 'products.id', '=','crms.product_id' )->select('crms.id','crms.projectid','crms.date','crms.projectname','crms.tcv','crms.estclosedate','crms.customer_id','crms.contactsource','crms.user_id','crms.stages_id','crms.product_id','users.firstname','users.lastname','customers.organisationname','customers.busunit','customers.countryregion','customers.contactfirstname','customers.contactlastname','customers.contactfunction','customers.contactphone','customers.contactemail','customers.address','customers.city','customers.stateorprovince','customers.pin','customers.website','sources.source','stages.stages','stages.odds','stages.color','products.productname')->where('crms.id',$id)->first();
        $history= history::OfCompany(Auth::user()->company_id)->select('trackdate','memo')->wherenull('histories.followup')->where('crm_id',$id)->get();
    $todolist= \App\history::OfCompany(Auth::user()->company_id)->join('crms', 'histories.crm_id', '=','crms.id' )->select('crms.id','crms.projectname','histories.followup','histories.todo','histories.memo','histories.closedate')->wherenotnull('histories.followup')->where('histories.crm_id',$id)->get();
       $stagelist= \App\stage::OfCompany(Auth::user()->company_id)->select('stages','id')->get();
        $employeelist=\App\User::OfCompany(Auth::user()->company_id)->select('firstname','lastname','id','offices_id')->get();
        $productlist= \App\product::OfCompany(Auth::user()->company_id)->select('id','productname')->get();
        $customerlist=\App\customer::OfCompany(Auth::user()->company_id)->select('organisationname','id')->get();
        $sourcelist=\App\source::OfCompany(Auth::user()->company_id)->select('source','id')->get();
         return view('project',['crm'=>$crm,'history'=>$history,'todolist'=>$todolist,'customerlist'=>$customerlist,'sourcelist'=>$sourcelist,'employeelist'=>$employeelist,'stagelist'=>$stagelist,'productlist'=>$productlist]);
    }
    protected function projecthead($id,$owner,$employee){
     $emps= User::where('managerid',$employee)->get();
       foreach ($emps as $row) {
            $employees_id = $row->id;
            if ($owner == $employees_id) {
                $crm= crm::with('Users')->join('users', 'users.id', '=','crms.user_id' )->join('customers', 'customers.id', '=','crms.organisation' )->select('crms.*', 'users.name','users.costcentreid','customers.organisationname')->where('crms.id',$id)->first();
        $history= history::where('crmid',$id)->get();
        $emp=User::where('costcentreid',$crm->costcentreid)->get();
//      ///  $emps= App\user::all();
    return view('projecthead',['crm'=>$crm,'emp'=>$emp,'history'=>$history]); 
            } else { $subemps= User::where('managerid',$employees_id)->get();
            foreach($subemps as $subrow) {
            $subemployees_id = $subrow->id;
            if ($owner == $subemployees_id){
                $crm= crm::with('Users')->join('users', 'users.id', '=','crms.user_id' )->join('customers', 'customers.id', '=','crms.organisation' )->select('crms.*', 'users.name','users.costcentreid','customers.organisationname')->where('crms.id',$id)->first();
        $history= history::where('crmid',$id)->get();
        $emp=User::where('costcentreid',$crm->costcentreid)->get();
//      ///  $emps= App\user::all();
    return view('projecthead',['crm'=>$crm,'emp'=>$emp,'history'=>$history]); 
            }
    }}} return $this->illegal($id,$owner);
     }
    protected function illegal($id,$owner){
        if(Auth::user()->u_rolecode=='System Admin')
        {
            $crm= crm::with('Users')->join('users', 'users.id', '=','crms.user_id' )->join('customers', 'customers.id', '=','crms.organisation' )->select('crms.*', 'users.name','users.costcentreid','customers.organisationname')->where('crms.id',$id)->first();
        $history= history::where('crmid',$id)->get();
        $emp=User::where('costcentreid',$crm->costcentreid)->get();
    return view('projecthead',['crm'=>$crm,'emp'=>$emp,'history'=>$history]); 
        }else{
        $ownername = User::select('name')->where('id',$owner)->first();
        
                        return view('privilege',['ownername'=>$ownername]);
        }
                    }
            
         
     protected function update($id,Request $request)
    {
         $this->validate($request, [
           'projectname'=>'required|string|max:255','source'=>'required|string|max:255',
           'stages' => 'required|string|max:255','amount' => 'nullable|numeric','deadline' => 'nullable|date',
            'product' => 'string|max:255', 'memo' => 'required|string', 'followup' => 'nullable|date',
       ]); //return view('index');
         $data['id'] = $id;
      $crmdata = crm::select('user_id')->where('id', $data['id'])->first();
     
        $owner=$crmdata->user_id;
        $employee= Auth::id();
        if($owner==$employee)
        {
            return $this->projectownerupdate($id,$request);
        }elseif ($owner != $employee) {
             
          return $this->projectheadupdate($id,$request);   
        } elseif(Auth::user()->u_rolecode=='System Admin')
        {
          return $this->projectheadupdate($id,$request);  
        }
        
     
    }
     protected function projectownerupdate($id,$request){
         $crmdata = crm::select('stages','tcv','estclosedate','product')->where('id',$id)->first();
        crm::where('id', $id)->update(['stages' =>$request->get('stages'),'tcv' =>$request->get('amount'),'estclosedate' =>$request->get('deadline'),'product' =>$request->get('product'),  ]);
        $defaultmemo = "\n\nSYSTEM GENERATED NOTES:-\n";
        if ($request->get('stages') != $crmdata->stages) {
            $defaultmemo = $defaultmemo . "* Stage Changed From " .$crmdata->stages. " To " .$request->get('stages'). "\n";
        }if ($request->get('amount') != $crmdata->tcv) {
            $defaultmemo = $defaultmemo . "* Amount changed From " . $crmdata->tcv . " To " . $request->get('amount') . "\n";
        }if ($request->get('deadline') != 0000 - 00 - 00) {
            if ($request->get('deadline') != $crmdata->estclosedate) {
                $defaultmemo = $defaultmemo . "* Deadline Changed From " . $crmdata->estclosedate . " To " . $request->get('deadline') . "\n";
            }} if ($request->get('product') != $crmdata->product) {
            $defaultmemo = $defaultmemo . "* Product Name Changed From " . $crmdata->product . " To " . $request->get('product') . "\n";
        }if ($defaultmemo == "\n\nSYSTEM GENERATED NOTES:-\n") {
            $defaultmemo = NULL;
        }$mymemo = $request->get('memo'). '' . $defaultmemo;
                history::create(['memo' => $mymemo,'trackdate'=>date('Y-m-d'),'followup'=>$request->get('followup'), 'crmid' =>$id,
        ]);       return Redirect::back();
                    }
        protected function projectheadupdate($id,$request){
         $crmdata = crm::select('projectname','contactsource','stages','tcv','estclosedate','product')->where('id',$id)->first();
        crm::where('id', $id)->update(['projectname'=>$request->get('projectname'),'contactsource'=>$request->get('source'),'stages' =>$request->get('stages'),'tcv' =>$request->get('amount'),'estclosedate' =>$request->get('deadline'),'product' =>$request->get('product'),  ]);
        $defaultmemo = "\n\nSYSTEM GENERATED MANAGER ACTION NOTES:-\n";
        if ($request->get('projectname') != $crmdata->projectname) {
            $defaultmemo = $defaultmemo . "* Project Name changed from " .$crmdata->projectname. " to " .$request->get('projectname'). "\n";
        }if ($request->get('source') != $crmdata->contactsource) {
            $defaultmemo = $defaultmemo . "* contact Source changed from " . $crmdata->contactsource . " to " . $request->get('source') . "\n";
        }
        if ($request->get('stages') != $crmdata->stages) {
            $defaultmemo = $defaultmemo . "* Stage changed from " .$crmdata->stages. " to " .$request->get('stages'). "\n";
        }if ($request->get('amount') != $crmdata->tcv) {
            $defaultmemo = $defaultmemo . "* Amount changed from " . $crmdata->tcv . " to " . $request->get('amount') . "\n";
        }if ($request->get('deadline') != 0000 - 00 - 00) {
            if ($request->get('deadline') != $crmdata->estclosedate) {
                $defaultmemo = $defaultmemo . "* Deadline changed from " . $crmdata->estclosedate . " to " . $request->get('deadline') . "\n";
            }} if ($request->get('product') != $crmdata->product) {
            $defaultmemo = $defaultmemo . "* Product name changed from " . $crmdata->product . " to " . $request->get('product') . "\n";
        }if ($defaultmemo == "\n\nSYSTEM GENERATED MANAGER ACTION NOTES:-\n") {
            $defaultmemo = NULL;
        }$mymemo = $request->get('memo'). '' . $defaultmemo;
                history::create(['memo' => $mymemo,'trackdate'=>date('Y-m-d'),'followup'=>$request->get('followup'), 'crmid' =>$id,
        ]);       return Redirect::back();
                   
                    }             
    
}